#!/usr/bin/python
#-*- coding:utf-8 -*-

import pycurl
import time
import json
import StringIO

from datetime import datetime
import random
import sys
import threading
import re

db_url=sys.argv[1]
metricName=sys.argv[2]
put_url='http://'+db_url+'/'+metricName+'/doc/_bulk'
userpwd='root:xxxxxxxxx'

dataNum=int(sys.argv[3])
threads_nmb=int(sys.argv[4])
counts=int(sys.argv[5])

def curl_data(datajson):
    buf = StringIO.StringIO()
    c = pycurl.Curl()
    c.setopt(pycurl.WRITEFUNCTION, buf.write)
    c.setopt(pycurl.URL, put_url)
    c.setopt(pycurl.HTTPHEADER, ['content-type: application/json'])
    c.setopt(pycurl.USERPWD, userpwd)
    c.setopt(pycurl.POST, 1)
    c.setopt(pycurl.POSTFIELDS, datajson)
    #c.setopt(pycurl.VERBOSE, 1)

    startTime=time.time()
    c.perform()
    endTime=time.time()

    the_page = buf.getvalue()
    buf.close()
    #print "datajson:",datajson
    #print "the_page:",the_page
    searchPart = re.search(r'errors":(.+),"items', the_page, re.M)
    if searchPart:
        errorsInfo= str(searchPart.group(1))
    	print "errorsInfo:",errorsInfo    
    else:
        print "get errorsInfo faild"
 

    diffTime=endTime-startTime
    #print "startTime:",startTime
    #print "endTime:",endTime
    #print "diffTime:",diffTime
    #print "wps:",dataNum/diffTime

def gen_data():
    datas=[]
    for i in range( dataNum ):
        datas.append( {"index":{}} )
        row = {
                "@timestamp":datetime.now().strftime( "%Y-%m-%dT%H:%M:%S.000+0800" ),
                "http_code" : "200"
        }
        # "count" : random.randint(  1, 100 )
        #print row
        rowjson=json.dumps(row)
        #print rowjson
        rowj1=rowjson[0:len(rowjson)-1]
	#print rowj1
	
	countstrs=""
	for i in range(counts):
		countstr=',"count'+str(i+1)+'":'+str(random.randint(1,100))
		countstrs=countstrs+countstr
	#print countstrs
	
	rowjsonall=rowj1+countstrs+'}'
	#print rowjsonall

        datas.append( rowjsonall) 

    datajson=""
    for i in range(len(datas)/2):
        datatem = json.dumps(datas[int(i*2)])+'\n'+datas[int((i*2)+1)]+'\n'
        datajson = datajson + datatem
    #print "datajson:\n",datajson
    return datajson

def gen_data_for_threads():
    datajsons=[]
    for i in range(threads_nmb):
        datajsons.append(gen_data())
    return datajsons


class curlThread(threading.Thread):
    def __init__(self, threadID, datajson):
        threading.Thread.__init__(self)
        self.threadID = threadID
        self.datajson = datajson
    def run(self):
        #print "start thread:",self.threadID,datetime.now().strftime("%Y-%m-%d %H:%M:%S")
        curl_data(self.datajson)
        #print "eixt thread:",self.threadID,datetime.now().strftime("%Y-%m-%d %H:%M:%S")


if __name__=='__main__':
    print "-------------- params --------------"
    print "put_url",put_url
    print 'dataNum:',dataNum
    print 'threads_nmb:',threads_nmb
    print 'counts:',counts

    datajsons=gen_data_for_threads()
    #print "datajsons:",datajsons
    print "-------------- results --------------"
    startTime=time.time()
    print "start all threads",datetime.now().strftime("%Y-%m-%d %H:%M:%S")
    threads = []
    threadID = 0
    for i in range(threads_nmb):
        thread=curlThread(threadID,datajsons[i])
        thread.start()
        threads.append(thread)
        threadID += 1

    for thread in threads:
        thread.join()
    print "exit all threads",datetime.now().strftime("%Y-%m-%d %H:%M:%S")
    endTime=time.time()
    
    diffTime=endTime-startTime
    print "startTime:",startTime
    print "endTime:",endTime
    print "diffTime:",diffTime
    print "wps:",dataNum*threads_nmb/diffTime


